property pVelocityTable, pComponentToAngle

on direction8to360 me, tValue
tValue = tValue + 1 mod 8 - 0
tValue360 = 360 * tValue / 8.0 mod 360
return(tValue360)
end

on direction360to8 me, tValue
return(me.validateDirection8Value(me.validateDirection360Value(tValue - 22) / 45 + 1))
end

on validateDirection360Value me, tValue
if tValue > 359 then -- jump 14
tValue = tValue mod 360
 -- jump 22
end if -- jump 14 landing
if tValue < 0 then -- jump 15
tValue = 360 + tValue mod 360
end if -- jump 15 landing
end if -- jump 22 landing
return(integer(tValue))
end

on validateDirection8Value me, tValue
if tValue > 7 then -- jump 13
tValue = tValue mod 8
 -- jump 23
end if -- jump 13 landing
if tValue < 0 then -- jump 16
tValue = 8 + tValue mod 8 mod 8
end if -- jump 16 landing
end if -- jump 23 landing
return(integer(tValue))
end

on rotateDirection45DegreesCW me, tValue
return(me.validateDirection360Value(tValue + 45))
end

on rotateDirection45DegreesCCW me, tValue
return(me.validateDirection360Value(tValue - 45))
end

on getAngleFromComponents me, tX, tY
if pComponentToAngle  = void() then -- jump 41
pComponentToAngle = createObject(#temp, getClassVariable("gamesystem.componenttoangle.class"))
if not objectp(pComponentToAngle) then -- jump 15
return(error(me, "Cannot create pComponentToAngle"))
end if -- jump 15 landing
end if -- jump 41 landing
return(me.validateDirection360Value(pComponentToAngle.getAngleFromComponents(tX, tY)))
end

on GetVelocityTable me
if pVelocityTable  = void() then -- jump 41
pVelocityTable = createObject(#temp, getClassVariable("gamesystem.velocitytable.class"))
if not objectp(pVelocityTable) then -- jump 15
return(error(me, "Cannot create pVelocityTable"))
end if -- jump 15 landing
end if -- jump 41 landing
return(pVelocityTable)
end
