property pLocX, pLocY, x, y, z, pTileWidth, pType, pContent, pGameSystem

on construct me
pContent = [:]
return(1)
end

on deconstruct me
pContent = void()
return(1)
end

on define me, tLocX, tLocY, tWorldX, tWorldY, tWidth, ttype, tFramework
pLocX = tLocX
pLocY = tLocY
x = tWorldX
y = tWorldY
z = 0
pTileWidth = tWidth
pType = ttype
pContent = [:]
pGameSystem = tFramework
return(1)
end

on addContent me, tItemID, tItemProps
pContent.addProp(tItemID, tItemProps)
return(1)
end

on removeContent me, tItemID
pContent.deleteProp(tItemID)
return(1)
end

on getTileNeighborInDirection me, tdir
tGameSystem = me.getGameSystem()
if tGameSystem  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
 --PEEKFROMSTACK 0 if tdir  = 0 then -- jump 28
 --TRIMFROMSTACK 1 
return(tGameSystem.getTile(pLocX, pLocY - 1))
 -- jump 266
end if -- jump 28 landing
 --PEEKFROMSTACK 0 
--nil--  = 1
if --nil-- then -- jump 31
 --TRIMFROMSTACK 1 
return(tGameSystem.getTile(pLocX + 1, pLocY - 1))
 -- jump 230
end if -- jump 31 landing
 --PEEKFROMSTACK 0 
--nil--  = 2
if --nil-- then -- jump 28
 --TRIMFROMSTACK 1 
return(tGameSystem.getTile(pLocX + 1, pLocY))
 -- jump 197
end if -- jump 28 landing
 --PEEKFROMSTACK 0 
--nil--  = 3
if --nil-- then -- jump 31
 --TRIMFROMSTACK 1 
return(tGameSystem.getTile(pLocX + 1, pLocY + 1))
 -- jump 161
end if -- jump 31 landing
 --PEEKFROMSTACK 0 
--nil--  = 4
if --nil-- then -- jump 28
 --TRIMFROMSTACK 1 
return(tGameSystem.getTile(pLocX, pLocY + 1))
 -- jump 128
end if -- jump 28 landing
 --PEEKFROMSTACK 0 
--nil--  = 5
if --nil-- then -- jump 31
 --TRIMFROMSTACK 1 
return(tGameSystem.getTile(pLocX - 1, pLocY + 1))
 -- jump 92
end if -- jump 31 landing
 --PEEKFROMSTACK 0 
--nil--  = 6
if --nil-- then -- jump 28
 --TRIMFROMSTACK 1 
return(tGameSystem.getTile(pLocX - 1, pLocY))
 -- jump 59
end if -- jump 28 landing
 --PEEKFROMSTACK 0 
--nil--  = 7
if --nil-- then -- jump 31
 --TRIMFROMSTACK 1 
return(tGameSystem.getTile(pLocX - 1, pLocY - 1))
 -- jump 23
end if -- jump 31 landing
 --TRIMFROMSTACK 1 
return(error(me, "Invalid direction for tile:" && tdir, #getTileNeighborInDirection))
end if -- jump 23 landing
end if -- jump 59 landing
end if -- jump 92 landing
end if -- jump 128 landing
end if -- jump 161 landing
end if -- jump 197 landing
end if -- jump 230 landing
end if -- jump 266 landing
 --TRIMFROMSTACK 1 
end

on getX me
return(pLocX)
end

on getY me
return(pLocY)
end

on getType me
return(pType)
end

on getWorldX me
return(x)
end

on getWorldY me
return(y)
end

on getWorldZ me
return(z)
end

on getWorldCoordinate me
return([#x: x, #y: y, #z: z])
end

on getLocation me
return([#x: pLocX, #y: pLocY])
end

on getDiameter me
return(pTileWidth * 100)
end

on locationIsInTileRange me, tLocX, tLocY
return(abs(pLocX - tLocX) <= 1 and abs(pLocY - tLocY) <= 1)
end

on worldLocationIsInTileRange me, tLocX, tLocY
return(abs(x - tLocX) < pTileWidth * 100 and abs(y - tLocY) < pTileWidth * 100)
end

on isInDistance me, tLocX, tLocY, tDistance
tDistanceX = abs(tLocX - x)
tDistanceY = abs(tLocY - y)
if tDistanceY > tDistance or tDistanceX > tDistance then -- jump 8
return(0)
end if -- jump 8 landing
if tDistanceX * tDistanceX + tDistanceY * tDistanceY < tDistance * tDistance then -- jump 9
return(1)
end if -- jump 9 landing
return(0)
end

on isBlockingLineOfSight me
put("* DEFAULT isBlockingLineOfSight, override!")
return(0)
end

on isAvailable me
return(not me.isOccupied() and me.isFloorTile())
end

on isOccupied me
return(pContent.count > 0)
end

on getOccupiedHeight me
if pContent.count  = 0 then -- jump 8
return(0)
end if -- jump 8 landing
tMaxHeight = 0
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(pContent) <= 1 then -- jump 46 -- backjump 49 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tItem = --nil--
if tItem.getaProp(#height) > tMaxHeight then -- jump 15
tMaxHeight = tItem.getaProp(#height)
end if -- jump 15 landing
--nil-- + 1
 -- backjump 49
end if -- jump 46 landing
 --TRIMFROMSTACK 3 
return(tMaxHeight)
end

on isFloorTile me
return(integerp(integer(pType)))
end

on dump me
return("Tile:" && pLocX & "," & pLocY & ":" && me.isAvailable() && me.getOccupiedHeight())
end

on getGameSystem me
return(pGameSystem)
end
