property m_mp_ar_rUsepool, m_mp_ar_rFreepool, m_iRefSource, m_iAllocationSize, m_rEmptyFactor, m_rEmptyVisual

on construct me
m_mp_ar_rUsepool = [:]
m_mp_ar_rFreepool = [:]
m_iRefSource = 0
m_iAllocationSize = 8
m_rEmptyFactor = createObject("StubFactor", "CEmptyFactor")
m_rEmptyVisual = createObject("StubVisual", "CEmptyVisualizer")
return(1)
end

on deconstruct me
me.clearAll()
removeObject("StubFactor")
removeObject("StubVisual")
return(1)
end

on clearAll me
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(m_mp_ar_rUsepool) <= 1 then -- jump 92 -- backjump 95 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
t_ar_pool = --nil--
if t_ar_pool.count > 0 then -- jump 68
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(t_ar_pool) <= 1 then -- jump 43 -- backjump 46 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tObject = --nil--
me.removeRoomObject(tObject.GetParam("CLASS"), tObject.GetParam("REF"))
--nil-- + 1
 -- backjump 46
end if -- jump 43 landing
 --TRIMFROMSTACK 3 
t_ar_pool = []
end if -- jump 68 landing
--nil-- + 1
 -- backjump 95
end if -- jump 92 landing
 --TRIMFROMSTACK 3 
m_mp_ar_rUsepool = [:]
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(m_mp_ar_rFreepool) <= 1 then -- jump 92 -- backjump 95 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
t_ar_pool = --nil--
if t_ar_pool.count > 0 then -- jump 68
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(t_ar_pool) <= 1 then -- jump 43 -- backjump 46 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tObject = --nil--
me.removeRoomObject(tObject.GetParam("CLASS"), tObject.GetParam("REF"))
--nil-- + 1
 -- backjump 46
end if -- jump 43 landing
 --TRIMFROMSTACK 3 
t_ar_pool = []
end if -- jump 68 landing
--nil-- + 1
 -- backjump 95
end if -- jump 92 landing
 --TRIMFROMSTACK 3 
m_mp_ar_rFreepool = [:]
end

on FreeAll me
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(m_mp_ar_rUsepool) <= 1 then -- jump 71 -- backjump 74 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
t_ar_pool = --nil--
if t_ar_pool.count > 0 then -- jump 47
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(t_ar_pool) <= 1 then -- jump 27 -- backjump 30 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tObject = --nil--
me.FreeObject(tObject)
--nil-- + 1
 -- backjump 30
end if -- jump 27 landing
 --TRIMFROMSTACK 3 
end if -- jump 47 landing
--nil-- + 1
 -- backjump 74
end if -- jump 71 landing
 --TRIMFROMSTACK 3 
end

on Reserve me, a_sClass, a_iCount
tClassPool = m_mp_ar_rFreepool.getaProp(a_sClass)
if voidp(tClassPool) then -- jump 15
m_mp_ar_rFreepool.setaProp(a_sClass, [])
end if -- jump 15 landing
tClassPool = m_mp_ar_rFreepool.getaProp(a_sClass)
if voidp(a_iCount) then -- jump 8
a_iCount = m_iAllocationSize
end if -- jump 8 landing
i = 1
if i <= a_iCount then -- jump 105 -- backjump 108 landing
tNewObject = me.createRoomObject(a_sClass, me.GetNewRef())
tNewObject.m_rFactor.deconstruct()
tNewObject.m_rVisual.deconstruct()
tNewObject.SetParam("StandardFactor", tNewObject.GetFactor())
tNewObject.SetParam("StandardVisual", tNewObject.getVisual())
tNewObject.m_rFactor = m_rEmptyFactor
tNewObject.m_rVisual = m_rEmptyVisual
tClassPool.append(tNewObject)
i = 1 + i
 -- backjump 108
end if -- jump 105 landing
end

on newObject me, a_sClass, a_mp_params
tClassPool = m_mp_ar_rFreepool.getaProp(a_sClass)
if voidp(tClassPool) then -- jump 12
me.Reserve(a_sClass)
end if -- jump 12 landing
tClassPool = m_mp_ar_rFreepool.getaProp(a_sClass)
if tClassPool.count < 1 then -- jump 12
me.Reserve(a_sClass)
end if -- jump 12 landing
tUsePool = m_mp_ar_rUsepool.getaProp(a_sClass)
if voidp(tUsePool) then -- jump 15
m_mp_ar_rUsepool.setaProp(a_sClass, [])
end if -- jump 15 landing
tUsePool = m_mp_ar_rUsepool.getaProp(a_sClass)
tObject = tClassPool[tClassPool.count]
tObject.m_rFactor = tObject.GetParam("StandardFactor")
tObject.m_rVisual = tObject.GetParam("StandardVisual")
tObject.m_rFactor.construct()
tObject.m_rVisual.construct()
tClassPool.deleteAt(tClassPool.count)
tUsePool.append(tObject)
if not voidp(a_mp_params) then -- jump 58
i = 1
if i <= a_mp_params.count then -- jump 44 -- backjump 49 landing
tKey = a_mp_params.getPropAt(i)
tValue = a_mp_params.getaProp(tKey)
tObject.SetParam(tKey, tValue)
i = 1 + i
 -- backjump 49
end if -- jump 44 landing
end if -- jump 58 landing
return(tObject)
end

on FreeObject me, a_rObject
t_sClass = a_rObject.GetParam("CLASS")
tUsePool = m_mp_ar_rUsepool.getaProp(t_sClass)
t_iIndex = tUsePool.getOne(a_rObject)
if t_iIndex  = 0 then -- jump 18
return(error(me, "ERROR : Objectpool reference mismatch!", #FreeObject))
end if -- jump 18 landing
tUsePool.deleteAt(t_iIndex)
tClassPool = m_mp_ar_rFreepool.getaProp(t_sClass)
tClassPool.append(a_rObject)
a_rObject.m_rFactor.deconstruct()
a_rObject.m_rVisual.deconstruct()
a_rObject.SetParam("StandardFactor", a_rObject.GetFactor())
a_rObject.SetParam("StandardVisual", a_rObject.getVisual())
a_rObject.m_rFactor = m_rEmptyFactor
a_rObject.m_rVisual = m_rEmptyVisual
return(1)
end

on createRoomObject me, a_sClass, a_iRef, a_mp_params
t_rXML = CreateXML()
t_rXML.open(getMember("empty.node.xml").text)
t_rXML.search("type", "NODE")
t_rXML.SetParam("REF", a_iRef)
t_rXML.SetParam("CLASS", a_sClass)
t_rRoomContext = getThread(#room).getComponent()._AccessRoom()
t_rRoomContext._CreateIndexed(a_iRef, a_sClass, t_rXML)
tNewObject = t_rRoomContext._AccessIndexed(a_iRef, a_sClass)
tNewObject.SetParam("Reference", a_iRef)
if not voidp(a_mp_params) then -- jump 58
i = 1
if i <= a_mp_params.count then -- jump 44 -- backjump 49 landing
tKey = a_mp_params.getPropAt(i)
tValue = a_mp_params.getaProp(tKey)
tNewObject.SetParam(tKey, tValue)
i = 1 + i
 -- backjump 49
end if -- jump 44 landing
end if -- jump 58 landing
return(tNewObject)
end

on removeRoomObject me, a_sClass, a_iRef
t_rRoomContext = getThread(#room).getComponent()._AccessRoom()
if not voidp(t_rRoomContext) then -- jump 14
t_rRoomContext._RemoveIndexed(a_iRef, a_sClass)
end if -- jump 14 landing
end

on GetNewRef me
m_iRefSource = m_iRefSource + 1
return(m_iRefSource)
end
