property pObjectId, pKilled, pGameSystem, pGameObjectSyncValues, pGameObjectValues, pGameObjectLocation, pGameObjectNextTarget, pGameObjectFinalTarget

on setObjectId me, tID
pGameObjectSyncValues = [:]
pGameObjectValues = [:]
pObjectId = tID
end

on getObjectId me
return(pObjectId)
end

on setGameObjectProperty me, tProp, tValue
if listp(tProp) then -- jump 59
tCount = tProp.count
i = 1
if i <= tCount then -- jump 35 -- backjump 38 landing
me.setGameObjectProperty(tProp.getPropAt(i), tProp[i])
i = 1 + i
 -- backjump 38
end if -- jump 35 landing
return(1)
end if -- jump 59 landing
if pGameObjectSyncValues.findPos(tProp) > 0 then -- jump 22
return(pGameObjectSyncValues.setProp(tProp, tValue))
 -- jump 18
end if -- jump 22 landing
return(pGameObjectValues.setaProp(tProp, tValue))
end if -- jump 18 landing
end

on getGameObjectProperty me, tProp
if pGameObjectSyncValues.findPos(tProp) > 0 then -- jump 20
return(pGameObjectSyncValues.getProp(tProp))
 -- jump 17
end if -- jump 20 landing
return(pGameObjectValues.getaProp(tProp))
end if -- jump 17 landing
end

on getActive me
return(not pKilled)
end

on setLocation me, tX, tY, tZ
if me.pGameObjectSyncValues.findPos(#x) then -- jump 17
me.pGameObjectSyncValues.setaProp(#x, tX)
end if -- jump 17 landing
if me.pGameObjectSyncValues.findPos(#y) then -- jump 17
me.pGameObjectSyncValues.setaProp(#y, tY)
end if -- jump 17 landing
if me.pGameObjectSyncValues.findPos(#z) then -- jump 17
me.pGameObjectSyncValues.setaProp(#z, tZ)
end if -- jump 17 landing
return(pGameObjectLocation.setLocation(tX, tY, tZ))
end

on setLocationAsTile me, tX, tY, tZ
pGameObjectLocation.setTileLoc(tX, tY, tZ)
if me.pGameObjectSyncValues.findPos(#x) then -- jump 21
me.pGameObjectSyncValues.setaProp(#x, pGameObjectLocation.x)
end if -- jump 21 landing
if me.pGameObjectSyncValues.findPos(#y) then -- jump 21
me.pGameObjectSyncValues.setaProp(#y, pGameObjectLocation.y)
end if -- jump 21 landing
if me.pGameObjectSyncValues.findPos(#z) then -- jump 21
me.pGameObjectSyncValues.setaProp(#z, pGameObjectLocation.z)
end if -- jump 21 landing
return(1)
end

on setGameSystemReference me, tObject
pGameSystem = tObject
end

on setGameObjectSyncProperty me, tList, tdata
if listp(tList) then -- jump 58
tCount = tList.count
i = 1
if i <= tCount then -- jump 37 -- backjump 40 landing
me.pGameObjectSyncValues.setaProp(tList.getPropAt(i), tList[i])
i = 1 + i
 -- backjump 40
end if -- jump 37 landing
 -- jump 16
end if -- jump 58 landing
me.pGameObjectSyncValues.setaProp(tList, tdata)
end if -- jump 16 landing
return(1)
end

on executeGameObjectEvent me, tEvent, tdata
 --PEEKFROMSTACK 0 if tEvent  = #set_target then -- jump 31
me.pGameObjectFinalTarget.setLoc(tdata.x, tdata.y, tdata.z)
 -- jump 37
end if -- jump 31 landing
 --PEEKFROMSTACK 0 
--nil--  = #set_target_tile
if --nil-- then -- jump 28
me.pGameObjectFinalTarget.setTileLoc(tdata.x, tdata.y, tdata.z)
end if -- jump 28 landing
end if -- jump 37 landing
 --TRIMFROMSTACK 1 
return(1)
end

on addChecksum me
tCheckSum = 0
tCounter = 1
tCount = pGameObjectSyncValues.count
i = 1
if i <= tCount then -- jump 128 -- backjump 131 landing
tValue = pGameObjectSyncValues[i]
tIlk = ilk(tValue)
if tIlk  = #integer then -- jump 20
tCheckSum = tCheckSum + tValue * tCounter
tCounter = tCounter + 1
end if -- jump 20 landing
if tIlk  = #list then -- jump 64
if tValue.count > 0 then -- jump 55
 --PEEKFROMSTACK 2  --PEEKFROMSTACK 0  --PEEKFROMSTACK 0 if count(tValue) <= 1 then -- jump 35 -- backjump 38 landing
 --PEEKFROMSTACK 2 
 --PEEKFROMSTACK 1 
[--nil--, --nil--]
getAt(-nil-)
tValueItem = --nil--
tCheckSum = tCheckSum + tValueItem * tCounter
tCounter = tCounter + 1
--nil-- + 1
 -- backjump 38
end if -- jump 35 landing
 --TRIMFROMSTACK 3 
end if -- jump 55 landing
end if -- jump 64 landing
i = 1 + i
 -- backjump 131
end if -- jump 128 landing
return(tCheckSum)
end

on define me
return(1)
end

on gameObjectRefreshLocation me
return(0)
end

on gameObjectNewMoveTarget me
return(0)
end

on calculateFrameMovement me
return(0)
end

on getLocation me
return(pGameObjectLocation)
end

on getNextTarget me
return(pGameObjectNextTarget)
end

on getFinalTarget me
return(pGameObjectFinalTarget)
end

on resetTargets me
pGameObjectNextTarget.setLoc(pGameObjectLocation.x, pGameObjectLocation.y, pGameObjectLocation.z)
pGameObjectFinalTarget.setLoc(pGameObjectLocation.x, pGameObjectLocation.y, pGameObjectLocation.z)
end

on existsFinalTarget me
if not objectp(pGameObjectFinalTarget) then -- jump 8
return(0)
end if -- jump 8 landing
if not objectp(pGameObjectLocation) then -- jump 8
return(0)
end if -- jump 8 landing
return(pGameObjectLocation.getLocation() <> pGameObjectFinalTarget.getLocation())
end

on existsNextTarget me
if not objectp(pGameObjectNextTarget) then -- jump 8
return(0)
end if -- jump 8 landing
if not objectp(pGameObjectLocation) then -- jump 8
return(0)
end if -- jump 8 landing
return(pGameObjectLocation.getLocation() <> pGameObjectNextTarget.getLocation())
end

on dump me, tServerFormat
if tServerFormat  = 1 then -- jump 236
tObjectId = me.getObjectId()
if tObjectId.length < 2 then -- jump 10
tObjectId = "0" & tObjectId
end if -- jump 10 landing
tDumpString = "O" & tObjectId & "-CS:" & me.addChecksum() && "Parms:"
i = 1
if i <= pGameObjectSyncValues.count then -- jump 151 -- backjump 157 landing
tValue = pGameObjectSyncValues[i]
if ilk(tValue)  = #integer then -- jump 28
tDumpString = tDumpString & tValue
if i < pGameObjectSyncValues.count then -- jump 10
tDumpString = tDumpString & ","
end if -- jump 10 landing
end if -- jump 28 landing
if ilk(tValue)  = #list then -- jump 78
if tValue.count > 0 then -- jump 69
j = 1
if j <= tValue.count then -- jump 55 -- backjump 60 landing
tListItem = tValue[j]
tDumpString = tDumpString & tListItem
if j <= tValue.count and i < pGameObjectSyncValues.count then -- jump 10
tDumpString = tDumpString & ","
end if -- jump 10 landing
j = 1 + j
 -- backjump 60
end if -- jump 55 landing
end if -- jump 69 landing
end if -- jump 78 landing
i = 1 + i
 -- backjump 157
end if -- jump 151 landing
tDumpString = "++" && QUOTE & tDumpString & QUOTE
return(tDumpString)
 -- jump 97
end if -- jump 236 landing
tDumpList = []
i = 1
if i <= pGameObjectSyncValues.count then -- jump 71 -- backjump 77 landing
tValue = pGameObjectSyncValues[i]
if ilk(tValue)  = #integer or ilk(tValue)  = #list then -- jump 25
tDumpList.add(pGameObjectSyncValues.getPropAt(i) & ":" && tValue)
end if -- jump 25 landing
i = 1 + i
 -- backjump 77
end if -- jump 71 landing
return(tDumpList)
end if -- jump 97 landing
end

on getGameSystem me
return(pGameSystem)
end

on Remove me
me.pKilled = 1
return(1)
end
