
on construct me
return(1)
end

on deconstruct me
return(1)
end

on Refresh me, tTopic, tdata
call(symbol("handle_" & tTopic), me, tdata)
return(1)
end

on handle_msgstruct_numtickets me, tMsg
tNum = tMsg.connection.GetIntFrom()
return(me.getGameSystem().sendGameSystemEvent(#numtickets, tNum))
end

on handle_msgstruct_notickets me, tMsg
return(me.getGameSystem().sendGameSystemEvent(#notickets, void()))
end

on handle_msgstruct_users me, tMsg
return(me.getGameSystem().sendGameSystemEvent(#users, tMsg))
end

on handle_msgstruct_loungeinfo me, tMsg
tConn = tMsg.connection
tdata = [:]
tdata.addProp(#tournament_flag, tConn.GetIntFrom())
if tdata[#tournament_flag] > 0 then -- jump 33
tdata.addProp(#tournament_logo_url, tConn.GetStrFrom())
tdata.addProp(#tournament_logo_click_url, tConn.GetStrFrom())
end if -- jump 33 landing
tdata.addProp(#lounge_skill_name, tConn.GetStrFrom())
tdata.addProp(#lounge_skill_score_min, tConn.GetIntFrom())
tdata.addProp(#lounge_skill_score_max, tConn.GetIntFrom())
return(me.getGameSystem().sendGameSystemEvent(#loungeinfo, tdata))
end

on handle_msgstruct_instancenotavailable me, tMsg
tConn = tMsg.connection
tID = tConn.GetIntFrom()
return(me.getGameSystem().sendGameSystemEvent(#instancenotavailable, tID))
end

on handle_msgstruct_gameparameters me, tMsg
tConn = tMsg.connection
tParamCount = tConn.GetIntFrom()
tParamList = []
i = 1
if i <= tParamCount then -- jump 256 -- backjump 258 landing
tItem = [:]
tItem.addProp(#name, tConn.GetStrFrom())
ttype = tConn.GetIntFrom()
tItem.addProp(#editable, tConn.GetIntFrom())
if ttype  = 0 then -- jump 91
tItem.addProp(#type, #integer)
tItem.addProp(#default, tConn.GetIntFrom())
if tConn.GetIntFrom()  = 1 then -- jump 19
tItem.addProp(#min, tConn.GetIntFrom())
end if -- jump 19 landing
if tConn.GetIntFrom()  = 1 then -- jump 19
tItem.addProp(#max, tConn.GetIntFrom())
end if -- jump 19 landing
 -- jump 97
end if -- jump 91 landing
tItem.addProp(#type, #string)
tItem.addProp(#default, tConn.GetStrFrom())
tItem.addProp(#choices, [])
tNumChoices = tConn.GetIntFrom()
if tNumChoices > 0 then -- jump 43
i = 1
if i <= tNumChoices then -- jump 31 -- backjump 34 landing
tItem[#choices].append(tConn.GetStrFrom)
i = 1 + i
 -- backjump 34
end if -- jump 31 landing
end if -- jump 43 landing
end if -- jump 97 landing
tParamList.append(tItem)
i = 1 + i
 -- backjump 258
end if -- jump 256 landing
return(me.getGameSystem().sendGameSystemEvent(#gameparameters, tParamList))
end

on handle_msgstruct_createfailed me, tMsg
tConn = tMsg.connection
tReason = tConn.GetIntFrom()
if tReason  = 1 then -- jump 31
tdata = [#reason: tReason, #request: "create", #key: tConn.GetStrFrom()]
 -- jump 18
end if -- jump 31 landing
tdata = [#reason: tReason, #request: "create"]
end if -- jump 18 landing
return(me.getGameSystem().sendGameSystemEvent(#createfailed, tdata))
end

on handle_msgstruct_gamedeleted me, tMsg
tConn = tMsg.connection
tID = tConn.GetIntFrom()
return(me.getGameSystem().sendGameSystemEvent(#gamedeleted, tID))
end

on handle_msgstruct_joinparameters me, tMsg
tConn = tMsg.connection
tInstanceId = tConn.GetIntFrom()
tParamCount = tConn.GetIntFrom()
tParamList = []
i = 1
if i <= tParamCount then -- jump 239 -- backjump 242 landing
tItem = [:]
tItem.addProp(#name, tConn.GetStrFrom())
ttype = tConn.GetIntFrom()
if ttype  = 0 then -- jump 91
tItem.addProp(#type, #integer)
tItem.addProp(#default, tConn.GetIntFrom())
if tConn.GetIntFrom()  = 1 then -- jump 19
tItem.addProp(#min, tConn.GetIntFrom())
end if -- jump 19 landing
if tConn.GetIntFrom()  = 1 then -- jump 19
tItem.addProp(#max, tConn.GetIntFrom())
end if -- jump 19 landing
 -- jump 97
end if -- jump 91 landing
tItem.addProp(#type, #string)
tItem.addProp(#default, tConn.GetStrFrom())
tItem.addProp(#choices, [])
tNumChoices = tConn.GetIntFrom()
if tNumChoices > 0 then -- jump 43
i = 1
if i <= tNumChoices then -- jump 31 -- backjump 34 landing
tItem[#choices].append(tConn.GetStrFrom)
i = 1 + i
 -- backjump 34
end if -- jump 31 landing
end if -- jump 43 landing
end if -- jump 97 landing
tParamList.append(tItem)
i = 1 + i
 -- backjump 242
end if -- jump 239 landing
return(me.getGameSystem().sendGameSystemEvent(#joinparameters, tParamList))
end

on handle_msgstruct_joinfailed me, tMsg
tConn = tMsg.connection
tReason = tConn.GetIntFrom()
if tReason  = 1 then -- jump 31
tdata = [#request: "join", #reason: tReason, #key: tConn.GetStrFrom()]
 -- jump 18
end if -- jump 31 landing
tdata = [#request: "join", #reason: tReason]
end if -- jump 18 landing
return(me.getGameSystem().sendGameSystemEvent(#joinfailed, tdata))
end

on handle_msgstruct_watchfailed me, tMsg
tConn = tMsg.connection
tInstanceId = tConn.GetIntFrom()
tReason = tConn.GetIntFrom()
return(me.getGameSystem().sendGameSystemEvent(#watchfailed, [#id: tInstanceId, #request: "watch", #reason: tReason]))
end

on handle_msgstruct_startfailed me, tMsg
tConn = tMsg.connection
tReason = tConn.GetIntFrom()
return(me.getGameSystem().sendGameSystemEvent(#startfailed, [#reason: tReason, #request: "start"]))
end

on handle_msgstruct_gamelocation me, tMsg
tConn = tMsg.connection
tUnitId = tConn.GetIntFrom()
tWorldId = tConn.GetIntFrom()
return(me.getGameSystem().sendGameSystemEvent(#gamelocation, [#unitId: tUnitId, #worldId: tWorldId]))
end

on handle_msgstruct_playerrejoined me, tMsg
tConn = tMsg.connection
tID = tConn.GetIntFrom()
return(me.getGameSystem().sendGameSystemEvent(#playerrejoined, [#id: tID]))
end

on handle_msgstruct_idlewarning me, tMsg
return(me.getGameSystem().sendGameSystemEvent(#idlewarning, void()))
end

on handle_msgstruct_skilllevelchanged me, tMsg
tConn = tMsg.connection
tLevel = tConn.GetStrFrom()
return(me.getGameSystem().sendGameSystemEvent(#skilllevelchanged, [#level: tLevel]))
end

on handle_msgstruct_heightmap me, tdata
tContent = tdata[#content]
if ilk(tContent) <> #string then -- jump 8
return(0)
end if -- jump 8 landing
if tContent.getProp(#line, tContent.count(#line))  = EMPTY then -- jump 16
delete char 35533 of tContent
end if -- jump 16 landing
tWorldMaxY = tContent.count(#line)
if tWorldMaxY < 1 then -- jump 18
return(error(me, "World is under 1 lines long!", #handle_msgstruct_heightmap))
end if -- jump 18 landing
tWorldMaxX = tContent.getPropRef(#line, 1).length
tArray = []
tLocY = 1
if tLocY <= tWorldMaxY then -- jump 62 -- backjump 65 landing
tLocX = 1
if tLocX <= tWorldMaxX then -- jump 41 -- backjump 44 landing
tArray.add(tContent.getPropRef(#line, tLocY).getProp(#char, tLocX))
tLocX = 1 + tLocX
 -- backjump 44
end if -- jump 41 landing
tLocY = 1 + tLocY
 -- backjump 65
end if -- jump 62 landing
return(me.getGameSystem().getWorld().storeHeightmap(tArray, tWorldMaxX, tWorldMaxY))
end

on handle_msgstruct_objects me, tdata
tList = []
tCount = tdata.content.count(#line)
i = 1
if i <= tCount then -- jump 374 -- backjump 376 landing
tLine = tdata.content.getProp(#line, i)
if length(tLine) > 5 then -- jump 334
tObj = [:]
tObj[#id] = tLine.getProp(#word, 1)
tObj[#class] = tLine.getProp(#word, 2)
tObj[#x] = integer(tLine.getProp(#word, 3))
tObj[#y] = integer(tLine.getProp(#word, 4))
tObj[#h] = integer(tLine.getProp(#word, 5))
if tLine.count(#word)  = 6 then -- jump 56
tdir = integer(tLine.getProp(#word, 6)) mod 8
tObj[#direction] = [tdir, tdir, tdir]
tObj[#dimensions] = 0
 -- jump 119
end if -- jump 56 landing
tWidth = integer(tLine.getProp(#word, 6))
tHeight = integer(tLine.getProp(#word, 7))
tObj[#dimensions] = [tWidth, tHeight]
tObj[#x] = tObj[#x] + tObj[#width] - 1
tObj[#y] = tObj[#y] + tObj[#height] - 1
end if -- jump 119 landing
if tObj[#id] <> EMPTY then -- jump 12
tList.add(tObj)
end if -- jump 12 landing
end if -- jump 334 landing
i = 1 + i
 -- backjump 376
end if -- jump 374 landing
return(me.getGameSystem().getWorld().storeObjects(tList))
end

on handle_msgstruct_game_chat me, tMsg
tConn = tMsg.connection
tUserID = string(tConn.GetIntFrom())
tChat = tConn.GetStrFrom()
tMode = "CHAT"
executeMessage(#show_balloon, [#command: tMode, #id: tUserID, #message: tChat])
end
